<?php

include './core.php';

cabecera (4);

$command = $_POST['command'];

switch ($command) {

   default:
      echo "<h1 class='title'>Selecci&oacute;n del fichero con la clave privada</h1>\n";

      echo "<form method='post' action='raPrivKey_import.php' enctype='multipart/form-data' name='request_import_selfile'>

      <div id='tbox'>
        <h3 class='head_a2b1'>Importacin</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>

            <div id='tname'>Fichero XML:</div>
            <div id='tvalue'><input type='file' name='importFile' size='35'></div>
          </div>
          <div id='trow'>
            <div id='tvalue'><input class='button' type='submit' value='Importar' /></div>
          </div>
        </div>
      </div>

      <input type='hidden' name='command' value='import' />

      </form>";
      break;

   case "import":

      $cantCert = 0;
      $errorCounter = 0;
      $importFileName = $_FILES['importFile']['name'];
    
      echo "<h1 class='title'>Importaci&oacute;n de Clave Privada</h1>\n";
      // Parseamos el fichero XML en un array
      $xmlData = parseXML($importFile);      
      
      // Comprobamos si ha habido algun error al hacer el parser
      if ( !$xmlData ) {
         $errorDescription = $errorDescription . "Error parseando el fichero $importFileName.";
         $errorNumber = 69;
         $errorCounter++;       
      }
      else {
         // Obtenemos el tipo de XML
         $xmlType = $xmlData[0]['xmlType'];         
         
         if ( $xmlType == '"private"' ) {
            $copaId = $xmlData[1]['copa_id'];
            $privKey = $xmlData[1]['private_key'];
            $date = $xmlData[1]['date'];

            // Creamos una cadena con un array que contendra la clave privada,
            // el codigo de la RA y la fecha del cambio de la clave. Este array
            // lo meteremos en un fichero junto con las claves privadas de las 
            // demas RAs
            $privKeyArrayString = "\$raPrivKeyArray['$copaId']['$date'] = \"$privKey\";\n";

            // Si no existe el fichero, lo creamos anyadiendole las etiquetas
            // de inicio y fin de fichero php
            if ( !file_exists($fileVar{private}) ) {
               $fd = fopen ($fileVar{private}, "w");
               $r1 = fputs ($fd, "<?php\n");
               $r2 = fputs ($fd, "?>\n");
               if ( !$fd || !$r1 || !$r2 ) {
                  $errorDescription = $errorDescription . "Error escribiendo en el fichero de claves ".$fileVar{private}.".";
                  $errorNumber = 69;
                  $errorCounter++;
               }
               fclose ($fd);
            }

            if ( $errorCounter == 0) {
               $fd2 = fopen ($fileVar{private}, "r+");
            
               // Nos posicionamos sobre la ultima linea, la que contiene el final
               // del fichero php (? >) y la sobreescribimos
               fseek($fd2, -3, SEEK_END);
               $r3 = fputs ($fd2, $privKeyArrayString);
               // Escribimos de nuevo el fin de fichero php
               $r4 = fputs ($fd2, "?>\n");            
               if ( !$fd2 || !$r3 || !$r4 ) {
                     $errorDescription = $errorDescription . "Error escribiendo en el fichero de claves ".$fileVar{private}.".";
                     $errorNumber = 69;
                     $errorCounter++;
               }
            
               fclose($fd2);          
            }
         }
         else {
            $errorDescription = $errorDescription . "Error parseando el fichero $importFileName. El tipo de datos del fichero XML no es el esperado.";
            $errorNumber = 69;
            $errorCounter++;
         }                    
      }

      // Escribimos en el fichero de log los cambios de estado realizados
      $status = "privKey";
      $user = "CA-Admin";
      writeLog ($status, $copa, $user, $errorNumber);

      if ( $errorCounter == 0 )
         echo "<p>La importac&oacute;n de las claves se ha realizado con &eacute;xito.</p>";
      else
         echo "<h1>Error importando las claves</h1>
         <p>$errorDescription Error $errorNumber</p>"; 

   break; 
}

pie ();

?>

